﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Http;
using DynamicRoutingExample.Models;
using System.Net;

namespace DynamicRoutingExample.Controllers
{
    public class FerretController : ApiController
    {
        [Route("ferret/{breedSlug}")]
        public FerretModel GetBySlug(string breedSlug)
        {
            var mockDatabase = new List<FerretModel>
            {
                new FerretModel
                {
                    Name = "Black Sable",
                    Slug = "black-sable",
                },
                new FerretModel
                {
                    Name = "Albino",
                    Slug = "albino"
                },
            };

            //check if the passed in slug exists in our database
            var ferret = mockDatabase.FirstOrDefault(f => string.Equals(breedSlug, f.Slug, StringComparison.InvariantCultureIgnoreCase));

            //throw 404 if not found in database
            if (ferret == null)
            {
                throw new HttpResponseException(HttpStatusCode.NotFound);
            }

            return ferret;
        }
    }
}
